#!/usr/bin/python
import socket, sys, thread, struct

size = 0
flags = 0
zeros = 0
data = ""
c = ""
connectlock = thread.allocate_lock()

def forward_read_server(s):
    global c
    global data
    strtotransmit = ""
    print str(c)
    while True:
        try:
            print "[SERVER] Receiving data"
            strtotransmit = c.recv(10240)
        except Exception, e:
            print "[SERVER] " + str(e)
            c.close()
            c = connect()
            if data != "":
                c.sendall(data)
            continue

        if strtotransmit == "":
            print "[SERVER] Socket disconnected"
            c.close()
            c = connect()
            if data != "":
                c.sendall(data)
            continue
        data = ""
        print "[SERVER] Received %d bytes" % len(strtotransmit)
        try:
            s.sendall(strtotransmit)
        except Exception, e:
            if s == client_socket:
                print "connexion vers serveur down, reconnexion"
                s.close()
                s = connect()
                print "transmitting waiting data"
                s.sendall(strtotransmit)
            else:
                raise
        print "[SERVER] Sent all data"

def forward_read_client(s):
    global c
    global data
    global client_socket
    strtotransmit = ""
    a = ""
    while True:
        magic = s.recv(4)
        type = s.recv(4)
        type2 = struct.unpack('I', type)
        print "type : " + str(type2[0])
        handle = s.recv(8)
        print "handle : " + handle
        nfrom = s.recv(8)
        print "nfrom : " + str(struct.unpack('II', nfrom))
        len = s.recv(4)
        print "len : " + str(struct.unpack('I', len)[0])
        strtotransmit = s.recv(1024)
        c.sendall(magic+type+handle+nfrom+len)
#       TODO : client may crash
        print "[CLIENT] Request received from client"
#        data = s.recv(28)
        ok = False
        while not ok:
            try:
                c.sendall(data)
                ok = True
            except:
                print "it crashed"
                c.close()
                c = connect()
        print "[CLIENT] Request send to server"

def connect():
    global client_socket
    global size
    global flags
    global zeros
    global connectlock

    connectlock.acquire()
    if c:
        try:
            c.getpeername()
            return c
        except socket.error:
            pass
    print "[CONNECT] Socket connecting"

    client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    #client_socket.connect(('10.145.2.108', 2002))
    client_socket.connect(('127.0.0.1', 2000))
    print "[CONNECT] Socket connected"

    magic = client_socket.recv(8)

    if magic != "NBDMAGIC":
        print "Failed NBDMAGIC"
        sys.exit(1)
    print "[CONNECT] Magic received"

    cliserv_magic = client_socket.recv(8)
    if cliserv_magic != "\x00\x00\x42\x02\x81\x86\x12\x53":
        print "Failed cliserv_magic"
        sys.exit(1)
    print "[CONNECT] cliserv received"

    size = client_socket.recv(8)
    print "[CONNECT] size received : " + str(struct.unpack('II', size))
    flags = client_socket.recv(4)
    print "[CONNECT] flags received"
    zeros = client_socket.recv(124)
    print "[CONNECT] zeros received"
    connectlock.release()
    return client_socket

c = connect()

server_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
server_socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
server_socket.bind(('', 20000))
server_socket.listen(1)

client, client_addr = server_socket.accept()
client.sendall("NBDMAGIC")
client.sendall("\x00\x00\x42\x02\x81\x86\x12\x53")
client.sendall(size)
client.sendall(flags)
client.sendall(zeros)

thread.start_new_thread(forward_read_client, (client,))
thread.start_new_thread(forward_read_server, (client,))

lock = thread.allocate_lock()
lock.acquire()
lock.acquire()



